public class Conta {
	private String numero;
	private double saldo;
	private Cliente cliente;

	public Conta(String num) {
	numero = num;
	saldo = 0;
	}
	public Conta(String num, double s) {
	numero = num;
	saldo = s;
	}
	public Conta(String num, double s, Cliente c) {
	numero = num;
	saldo = s;
        cliente = c;
	}

	public void creditar(double valor){
	  saldo = saldo + valor;
	}
	public void debitar(double valor){
	  if(valor <= saldo){
	  	saldo = saldo - valor;
	  }else{
	  	throw new RuntimeException("Saldo insuficiente");
	  }
	}
	public Cliente getCliente(){
	  return cliente;
	}
	public String getNumero() {
	  return numero;
	}
	public double getSaldo() {
	  return saldo;
	}
	public void setCliente(Cliente cliente) {
	  if (cliente == null) {
		throw new IllegalArgumentException("Argumento cliente nulo");
	  }
	  this.cliente = cliente;
	}
	public void setNumero(String num) {
	  if (num == null) {
		throw new IllegalArgumentException("Argumento codigo nulo!");
	  }
	  this.numero = num;
	}
	public void setSaldo(double valor) {
	  saldo = valor;
	}
	public void transferir(Conta c, double v) {
		this.debitar(v);
	 	c.creditar(v);
	}
	public boolean equals(Object outraConta) {
	  boolean resultado = true;
	  if (outraConta instanceof Conta) {
		Conta temp = (Conta) outraConta;
		resultado = resultado && (this.numero.equals(temp.numero));
	  }
	  return resultado;
	}
}
